#include "24l01.h"
#include "lcd.h"
#include "delay.h"
#include "spi.h"
//Mini STM32
//NRF24L01  
//ԭ@ALIENTEK
//2010/6/16	  
	 
const u8 TX_ADDRESS[TX_ADR_WIDTH]={0x34,0x43,0x10,0x10,0x01}; //͵ַ
const u8 RX_ADDRESS[RX_ADR_WIDTH]={0x34,0x43,0x10,0x10,0x01}; //͵ַ
 							    
//ʼ24L01IO
void NRF24L01_Init(void)
	{
	GPIO_InitTypeDef GPIO_InitStructure;
 
	RCC_APB2PeriphClockCmd(	RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOC, ENABLE );	

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP ;   //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	GPIO_SetBits(GPIOA,GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP ;   //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure); 
	GPIO_SetBits(GPIOC,GPIO_Pin_4);

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU  ;   //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOC, &GPIO_InitStructure);

	SPIx_Init();    //ʼSPI
	
	Clr_NRF24L01_CE;	 //ʹ24L01  NRF24L01_CE
	Set_NRF24L01_CSN;    //SPIƬѡȡ NRF24L01_CSN	 		  
	}

//24L01Ƿ
//ֵ:0ɹ;1ʧ	
u8 NRF24L01_Check(void)
	{
	u8 buf[5]={0XA5,0XA5,0XA5,0XA5,0XA5};
	u8 i;
	SPIx_SetSpeed(SPI_BaudRatePrescaler_8); //spiٶΪ9Mhz24L01SPIʱΪ10Mhz   	 
	NRF24L01_Write_Buf(NRF24L01_WRITE_REG+TX_ADDR,buf,5);//д5ֽڵĵַ.	
	NRF24L01_Read_Buf(TX_ADDR,buf,5); //дĵַ  
	for(i=0;i<5;i++)if(buf[i]!=0XA5)break;	 							   
	if(i!=5)return 1;//24L01	
	return 0;		 //⵽24L01
	}	
 	 
//SPIдĴ
//reg:ָĴַ
//value:дֵ
u8 NRF24L01_Write_Reg(u8 reg,u8 value)
	{
	u8 status;	
	Clr_NRF24L01_CSN;                 //ʹSPI
	status =SPIx_ReadWriteByte(reg);//ͼĴ 
	SPIx_ReadWriteByte(value);      //дĴֵ
	Set_NRF24L01_CSN;                 //ֹSPI	   
	return(status);       			//״ֵ̬
	}

//ȡSPIĴֵ
//reg:ҪļĴ
u8 NRF24L01_Read_Reg(u8 reg)
	{
	u8 reg_val;	    
	Clr_NRF24L01_CSN;          //ʹSPI		
	SPIx_ReadWriteByte(reg);   //ͼĴ
	reg_val=SPIx_ReadWriteByte(0XFF);//ȡĴ
	Set_NRF24L01_CSN;          //ֹSPI		    
	return(reg_val);           //״ֵ̬
	}	

//ָλöָȵ
//reg:Ĵ(λ)
//*pBuf:ָ
//len:ݳ
//ֵ,˴ζ״̬Ĵֵ 
u8 NRF24L01_Read_Buf(u8 reg,u8 *pBuf,u8 len)
	{
	u8 status,u8_ctr;	       
	Clr_NRF24L01_CSN;           //ʹSPI
	status=SPIx_ReadWriteByte(reg);//ͼĴֵ(λ),ȡ״ֵ̬   	   
	for(u8_ctr=0;u8_ctr<len;u8_ctr++)pBuf[u8_ctr]=SPIx_ReadWriteByte(0XFF);//
	Set_NRF24L01_CSN;       //رSPI
	return status;        //ض״ֵ̬
	}

//ָλдָȵ
//reg:Ĵ(λ)
//*pBuf:ָ
//len:ݳ
//ֵ,˴ζ״̬Ĵֵ
u8 NRF24L01_Write_Buf(u8 reg, u8 *pBuf, u8 len)
	{
	u8 status,u8_ctr;	    
	Clr_NRF24L01_CSN;          //ʹSPI
	status = SPIx_ReadWriteByte(reg);//ͼĴֵ(λ),ȡ״ֵ̬
	for(u8_ctr=0; u8_ctr<len; u8_ctr++)SPIx_ReadWriteByte(*pBuf++); //д	 
	Set_NRF24L01_CSN;       //رSPI
	return status;          //ض״ֵ̬
	}
				   
//NRF24L01һ
//txbuf:׵ַ
//ֵ:״
u8 NRF24L01_TxPacket(u8 *txbuf)
	{
	u8 sta;
	SPIx_SetSpeed(SPI_BaudRatePrescaler_8);//spiٶΪ9Mhz24L01SPIʱΪ10Mhz   
	Clr_NRF24L01_CE;
	NRF24L01_Write_Buf(NRF24L01_WR_TX_PLOAD,txbuf,TX_PLOAD_WIDTH);//дݵTX BUF  32ֽ
	Set_NRF24L01_CE;//	   
	while(NRF24L01_IRQ!=0);//ȴ
	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ	   
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&MAX_TX)//ﵽط
		{
		NRF24L01_Write_Reg(NRF24L01_FLUSH_TX,0xff);//TX FIFOĴ 
		return MAX_TX; 
		}
	if(sta&TX_OK)//
		{
		return TX_OK;
		}
	return 0xff;//ԭʧ
	}

//NRF24L01һ
//txbuf:׵ַ
//ֵ:0ɣ
u8 NRF24L01_RxPacket(u8 *rxbuf)
	{
	u8 sta;		    							   
	SPIx_SetSpeed(SPI_BaudRatePrescaler_8); //spiٶΪ9Mhz24L01SPIʱΪ10Mhz   
	sta=NRF24L01_Read_Reg(STATUS);  //ȡ״̬Ĵֵ    	 
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+STATUS,sta); //TX_DSMAX_RTжϱ־
	if(sta&RX_OK)//յ
		{
		NRF24L01_Read_Buf(NRF24L01_RD_RX_PLOAD,rxbuf,RX_PLOAD_WIDTH);//ȡ
		NRF24L01_Write_Reg(NRF24L01_FLUSH_RX,0xff);//RX FIFOĴ 
		return 0; 
		}	   
	return 1;//ûյκ
	}	
					    
//úʼNRF24L01RXģʽ
//RXַ,дRXݿ,ѡRFƵ,ʺLNA HCURR
//CEߺ,RXģʽ,Խ		   
void RX_Mode(void)
	{
	Clr_NRF24L01_CE;	  
	NRF24L01_Write_Buf(NRF24L01_WRITE_REG+RX_ADDR_P0,(u8*)RX_ADDRESS,RX_ADR_WIDTH);//дRXڵַ
	
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+EN_AA,0x01);    //ʹͨ0ԶӦ    
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+EN_RXADDR,0x01);//ʹͨ0Ľյַ  	 
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+RF_CH,40);	     //RFͨƵ		  
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+RX_PW_P0,RX_PLOAD_WIDTH);//ѡͨ0Чݿ 	    
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+RF_SETUP,0x0f);//TX,0db,2Mbps,濪   
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+CONFIG, 0x0f);//ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ 
	Set_NRF24L01_CE; //CEΪ,ģʽ 
	}
							 
//úʼNRF24L01TXģʽ
//TXַ,дTXݿ,RXԶӦĵַ,TX,ѡRFƵ,ʺLNA HCURR
//PWR_UP,CRCʹ
//CEߺ,RXģʽ,Խ		   
//CEΪߴ10us,.	 
void TX_Mode(void)
	{														 
	Clr_NRF24L01_CE;	    
	NRF24L01_Write_Buf(NRF24L01_WRITE_REG+TX_ADDR,(u8*)TX_ADDRESS,TX_ADR_WIDTH);//дTXڵַ 
	NRF24L01_Write_Buf(NRF24L01_WRITE_REG+RX_ADDR_P0,(u8*)RX_ADDRESS,RX_ADR_WIDTH); //TXڵַ,ҪΪʹACK	  
	
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+EN_AA,0x01);     //ʹͨ0ԶӦ    
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+EN_RXADDR,0x01); //ʹͨ0Ľյַ  
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+SETUP_RETR,0x1a);//Զطʱ:500us + 86us;Զط:10
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+RF_CH,40);       //RFͨΪ40
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+RF_SETUP,0x0f);  //TX,0db,2Mbps,濪   
	NRF24L01_Write_Reg(NRF24L01_WRITE_REG+CONFIG,0x0e);    //ûģʽĲ;PWR_UP,EN_CRC,16BIT_CRC,ģʽ,ж
	Set_NRF24L01_CE;//CEΪ,10us
	}		  




